#include "chebychev.h"
#include <math.h>

chebychev::chebychev ( void ) : objective_function ()
{
    int i;

    Dim = 9;
    Domain = new p_double [Dim];
    for ( i=0; i<Dim; i++ )
    {
        Domain[i] = new double [3];
        Domain[i][0] = -100.0;
        Domain[i][1] = 100.0;
        Domain[i][2] = 0.0;
    }

    optimum = new double;
    *optimum = 0.0;
    precision = 0.00001;
    sprintf ( name, "chebychev" );
    outfile = new char [256];
    outfile = &(name[0]);
}

chebychev::~chebychev ( void )
{
}

double chebychev::value ( double *oCH )
{
    int i, j;
    int const M=60;
    float px, x=-1.0, dx, result=0.0;

    dx = ( double ) M;
    dx = 2.0/dx;
    for (i=0;i<=M;i++)
    {
      px = oCH[0];
      for (j=1;j<Dim;j++)
      {
         px = x*px + oCH[j];
      }
      if (px<-1.0 || px>1.0) result+=(1.0-px)*(1.0-px);
      x+=dx;
   }
   px = oCH[0];
   for (j=1;j<Dim;j++) px=1.2*px+oCH[j];
   px = px-72.661;
   if (px<0.0) result+=px*px;
   px = oCH[0];
   for (j=1;j<Dim;j++) px=-1.2*px+oCH[j];
   px =px-72.661;
   if (px<0.0) result+=px*px;

   return -result;
}



