#include <stdio.h>
#include <math.h>
#include "fswe.h"

fswe::fswe ( void ) : objective_function ()
{
    int i,j, source=0;
    double Top=0.0, Source=0.0;

    FILE *f;

    f=fopen ( "fswe/calc", "rt" );
    fscanf ( f, "%d",&source );
    Source = floor ( ( double ) source/100.0 );
    fclose ( f );

    f=fopen ( "fswe/calc", "wt" );
    fprintf ( f, "%d", source+1 );
    fclose ( f );

    source = ( int ) Source;

    f=fopen ( "fswe/index", "rt" );
    for ( i=0; i<source; i++ ) fscanf ( f, "%d\n", &Dim );
    fclose ( f );

    for ( j=0; j<Members; j++ )
    {
        Peaks[j].y_0 = random_double ( y0min, y0max );
        Peaks[j].x_0 = new double [Dim];
        for ( i=0; i<Dim; i++ )
        {
            Peaks[j].x_0[i] = random_double ( xmin, xmax );
        }
    }

    for ( j=0; j<Members; j++ )
    {
        Peaks[j].value = value ( Peaks[j].x_0 );
        if ( Peaks[j].value > Top )
        {
            Top=Peaks[j].value;
            top=j;
        }
    }

    Domain = new p_double [Dim];
    for ( i=0; i<Dim; i++ )
    {
        Domain[i] = new double [3];
        Domain[i][0]=xmin;
        Domain[i][1]=xmax;
        Domain[i][2]=0.0;
    }

    optimum = new double;
    *optimum = Top;
    precision = 0.001;
    sprintf ( name, "fswe" );
    outfile = new char [256];
    sprintf ( outfile, "%s_%d", name,Dim );
}

fswe::~fswe ( void )
{
}

void fswe::evaluate (  double *oCH )
{
}

double fswe::value ( double *oCH )
{
    double yi, y=0.0;
    int i,j;
    
    for ( i=0; i<Members; i++ )
    {
        yi=0.0;
        for ( j=0; j<Dim; j++ )
        {
            yi += ( oCH[j]-Peaks[i].x_0[j] )*( oCH[j]-Peaks[i].x_0[j] );
        }
        yi = -sqrt( yi )/r0;
        y += Peaks[i].y_0*( atan( yi )+M_PI_2 );
    }
    return y;
}

