#if !defined ( __GARTOU__ )
#define        __GARTOU__

#if !defined ( __OBJECTIVE_FUNCTION__ )
#include "function.h"
#endif

#if defined ( __HAVE_KRESLITKO__ )

#include <kreslitko.h>

#define _X 2
#define _Y 1

#define CloseSignal 101
#define NextSignal 102
#define StartStopSignal 103

#endif

struct extreme
{
    double *location, value, *radius;
};

class gartou
{
    public:
        gartou ( void );
        ~gartou ( void );
        void run ( double *assessment=NULL );
        int vilog;
        int vilog_gati;
        int fitness_calls_limit;

    private:
// -------------------------------------- SADE TECHNOLOGY --------------------------------------------------
        double* new_point ( void );
        void configuration ( void );
        void EVALUATE_GENERATION ( int start );
        void SELECT ( void );
        void MUTATE ( void );
        void LOCAL_MUTATE ( void );
        void CROSS ( void );
        void FIRST_GENERATION ( void);
        void clear_pool ( void );
// -------------------------------------- CERAF TECHNOLOGY -------------------------------------------------
        void init_ceraf ( void );
        int new_ceraf ( void );
        void check_ceraf_distance ( int start );
        void clear_ceraf ( void );
// -------------------------------------- STOPPING CRITERIA ------------------------------------------------
        int to_continue ();

//--------------------------------------- VISUALISATION AND LOGGING ----------------------------------------
        void init_vilog ( void );
        int vilog_news ( int ceraf );
        void vilog_results ();
        void vilog_make_out ();
        void close_vilog ( void );
#if defined ( __HAVE_KRESLITKO__ )
        kreslitko *Ko ;
        int running ;
        void open_graphics ( void );
        void draw_chromos ( double **och , int on );
        void draw_cerafs ( double **olocations, double **oradius, int on );
        int until_next_step ( void );
        void close_graphics ( void );
#endif

//------------------variables of SADE:
    public:
        int pool_rate;
        double radioactivity, local_radioactivity;
        double mutation_rate, mutagen_rate;
        double cross_rate;
        objective_function *F;

    private:
        int ActualSize, generation, fitness_call, PoolSize, SelectedSize;
        double *Force, *mutagen;
        p_double *CH;

        double *bsf, bsf_value, *btg, btg_value;
//------------------variables of CERAF:
    public:
        int ExtremeSize, quiet;
        double radius_rate, disinteg_rate;

    private:
        int n_extreme, killed, monsters;
        p_double *all_locations, *all_radius;
        extreme *Extremes;
        int id, lastchange;
        double lastbtg, quiet_generation;
};
#endif