#include "gati.h"
#include <math.h>

gati::gati ( void ) : objective_function ()
{
    int i;

    Dim = 9;
    Domain = new p_double [Dim];
    for ( i=0; i<Dim; i++ )
    {
        Domain[i] = new double [3];
        Domain[i][2] = 0.0;
    }

    Domain[0][0] = 10.0;   // pool_rate
    Domain[0][1] = 100.0;
    Domain[0][2] = 1.0;
    
    Domain[1][0] = 0.0;   // radioactivity
    Domain[1][1] = 1.0;
    Domain[1][2] = 0.0;

    Domain[2][0] = 0.0;   // local_radioactivity
    Domain[2][1] = 1.0;
    Domain[2][2] = 0.0;
    
    Domain[3][0] = 0.0;   // mutation_rate
    Domain[3][1] = 1.0;
    Domain[3][2] = 0.0;

    Domain[4][0] = 1.0;   // mutagen_rate
    Domain[4][1] = 100000.0;
    Domain[4][2] = 1.0;

    Domain[5][0] = 0.0;   // cross_rate
    Domain[5][1] = 2.0;
    Domain[5][2] = 0.0;

    Domain[6][0] = 0.0;   // radius_rate
    Domain[6][1] = 1.0;
    Domain[6][2] = 0.0;

    Domain[7][0] = 0.0;   // disinteg_rate
    Domain[7][1] = 1.0;
    Domain[7][2] = 0.0;

    Domain[8][0] = 1.0;   // quiet
    Domain[8][1] = 10000.0;
    Domain[8][2] = 1.0;

    precision = 0.000000001;
    sprintf ( name, "gati" );
    Return_to_domain = 1;
}

void gati::create ( void )
{
    outfile = new char [256];
    sprintf ( outfile, "%s_%s", name, F->name );
}

gati::~gati ( void )
{
}

double gati::value ( double *oCH )
{
    int i;
    double assessment;
    gartou A;

    A.fitness_calls_limit=200000;
    A.vilog = 0;
    A.vilog_gati = 0;

    A.pool_rate = ( int ) oCH[0];
    A.radioactivity = oCH[1];
    A.local_radioactivity = oCH[2];
    A.mutation_rate = oCH[3];
    A.mutagen_rate = oCH[4];
    A.cross_rate = oCH[5];
    A.radius_rate = oCH[6];
    A.disinteg_rate  = oCH[7];
    A.quiet = ( int ) oCH[8];

    A.F=F;
    A.run ( &assessment );

    return assessment;
}



