#include <stdio.h>
#include <math.h>
#include "michal.h"

michal::michal ( void ) : objective_function ()
{
    int i,calc;
    char file[25];

    FILE *f;
    f = fopen ( "michal.dat/calc", "rt" );
    fscanf ( f, "%d", &calc );
    fclose ( f );
    if ( calc>30 ) calc-=30;
    f = fopen ( "michal.dat/calc", "wt" );
    fprintf ( f, "%d", calc+1 );
    fclose ( f );

    outfile = new char [10];
    f = fopen ( "michal.dat/index", "rt" );
    for ( i=0; i<calc; i++ ) fscanf ( f, "%s", outfile );
    fclose ( f );
    sprintf ( file, "michal.dat/%s", outfile );

    f = fopen ( file, "rt" );
    fscanf ( f, "%d", &points );
    b = new bod [points];
    for ( i=0; i<points; i++ )
    {
        fscanf ( f, "%lf", &b[i].x );
        fscanf ( f, "%lf", &b[i].y );
    }
    fclose ( f );

    Dim = 3;
    Domain = new p_double [Dim];
    for ( i=0; i<Dim; i++ ) Domain[i] = new double [3];
    Domain[0][0]=0.0001;  //alpha
    Domain[0][1]=100.0;
    Domain[0][2]=0.0;
    Domain[1][0]=1.0;     //n
    Domain[1][1]=6.5;
    Domain[1][2]=0.0;
    Domain[2][0]=0.0;     //m
    Domain[2][1]=1.0;
    Domain[2][2]=0.0;

    optimum = new double;
    *optimum = 0.0;
    precision = 0.000000001;
    Return_to_domain=1;
}

michal::~michal ( void )
{
    delete [] b;
    delete [] outfile;
}

double michal::value ( double *oCH )
{
    int i;
    double f=0.0, a, n, m;

    a=oCH[0];
    n=oCH[1];
    m=oCH[2];

    for (i=0; i<points; i++)
    {
        f+=(b[i].y/b[0].y-1/(pow((1.0+a*pow(sqrt(b[i].x*b[i].x),n)),m)))*(b[i].y/b[0].y-1/(pow((1.0+a*pow(sqrt(b[i].x*b[i].x),n)),m)));
    }

    return -f;
}
