/*
 * id.c
 *
 * Definice Obecne tridy
 *
 * M. Leps, 16.12.1999
 *
 */

#include <stdlib.h>

#include "id.h"

#include <string.h>
#include <stdio.h>

int ClassType::sameClass ( const char* oname ) const 
{ 
  return ( !strcmp( oname, className() )) ; 
}

int ClassType::sameGroup ( const ClassType *oc ) const
{
  return ( groupID() == oc->groupID() ) ;
}

void ClassType::checkGroup ( const ClassType *oc ) const
{
  if( !sameGroup( oc )) {
    noCompatible( oc ) ;
    exit(0) ;
  }
}

void ClassType::noCompatible ( const ClassType *oslave ) const 
{ 
#if defined STDDBG
  printf( "-- %s cannot operete with %s , exiting ...\n", className(), oslave->className() ) ; 
#endif
}

void ClassType::echoCtor()
{
#if defined STDDBG
  printf( "** %s constructor ** \n", className() ) ;
#endif
}

void ClassType::echoDtor()
{
#if defined STDDBG
  printf( "** %s destructor ** \n", className() ) ;
#endif
}


