/*
 * id.h
 *
 * Deklarace Obecne tridy
 *
 * M. Leps, 16.12.1999
 *
 */

#ifndef __ID_H__
#define __ID_H__

#define GBasic      10
#define GBinary     11
#define GReal       12

#define CGen                   "Gen"
#define CBinaryGen             "BinaryGen"
#define CRealGen               "RealGen"
#define CChromozom             "Chromozom"
#define CBinaryChromozom       "BinaryChromozom"
#define CRealChromozom         "RealChromozom"
#define CCoding                "Coding"
#define CBinaryCoding          "BinaryCoding"
#define CRealCoding            "RealCoding"
#define CSampling              "Sampling"
#define CRuleta                "Ruleta"
#define CRsis                  "Rsis"
#define CSus                   "Sus"
#define CPopulace              "Populace"
#define CScaling               "Scaling"
#define CLinearScaling         "LinearScaling"
#define CPufile                "Pufile"
#define CBasicGA               "BasicGA"
#define CGoldGA                "GoldGA"
#define CMichGA                "MichGA"
#define CStateGA               "StateGA"
#define CAusaGA                "AusaGA"
#define CPopCoding             "PopCoding"
#define CFunkce                "Funkce"
#define CPopVar                "VariablesPopulation"

class ClassType
{
    public:
      int sameClass ( const char* oname ) const ;
      int sameGroup ( const ClassType *oc ) const ;
      void checkGroup ( const ClassType *oc ) const ;
      void noCompatible ( const ClassType *oslave ) const ;
      void echoCtor() ;
      void echoDtor() ;
      virtual const char* className() const { return ( "no class" ) ; }
      virtual const int groupID() const { return ( GBasic ) ; }
} ;

#define DefineClass( oname, ogid ) \
     const char* className() const { return ( oname ) ; } \
     const int groupID() const { return ( ogid ) ; }

#endif
