/*
 * main.c		ver. 1.0
 *
 * Soubor na testovani fci v PU
 *
 * M. Leps, 3.3.99
 *
 */

#include <math.h>
#include <stdlib.h>

#include "variable.h"
#include "rc.h"

/**************************************************************************
 *
 * Globalni promenne
 *
 **************************************************************************/

/* optimalizovana funkce */
//Funkce GlobalFunkce ;

/**************************************************************************
 *
 * priklady funkci
 *
 **************************************************************************/


static TSKce  *kce ;
static PopVar pr ;


double Funkce_rc ( double *v )
{
  pr.clear_res() ;

  pr[0].r = v[0] ; // pb->b;
  pr[1].r = v[1] ; //  pb->h;
  pr[2].i = (int) v[2] ; //  pb->pr[DOLNI];
  pr[3].i = (int) v[3] ; //  pb->pr[HORNI];
  pr[4].i = (int) v[4] ; //  pb->m[0].as[DOLNI].n;
  pr[5].i = (int) v[5] ; //  pb->m[1].as[DOLNI].n;
  pr[6].i = (int) v[6] ; //  pb->m[2].as[DOLNI].n;
  pr[7].i = (int) v[7] ; //  pb->m[0].as[HORNI].n;
  pr[8].i = (int) v[8] ; //  pb->m[1].as[HORNI].n;
  pr[9].i = (int) v[9] ; //  pb->m[2].as[HORNI].n;
  pr[10].i = (int) v[10] ; //  pb->m[0].s;
  pr[11].i = (int) v[11] ; //  pb->m[1].s;

  //smyk
  pr[12].i = (int) v[12] ; //  pb->w[0].s;
  pr[13].i = (int) v[13] ; //  pb->w[1].s;
  pr[14].i = (int) v[14] ; //  pb->prw;
  pr[15].r = v[15] ; //  pb->w[0].sw;
  pr[16].r = v[16] ; //  pb->w[1].sw;
  pr[17].r = v[17] ; //  pb->w[2].sw;
  pr[18].i = 2 ; //  pb->w[0].pw;
  pr[19].i = 2 ; //  pb->w[1].pw;
  pr[20].i = 2; //  pb->w[2].pw;
  
  OP_silaGen(  pr, kce->pdb ) ;

  return( pr.f ) ;
}

/**************************************************************************
 *
 * Main
 *
 **************************************************************************/

int main ( int oc , char *ov[] )
{
  printf( "** \n" ) ;
  printf( "** Medved 0.6: running ...\n" ) ;
  printf( "** \n" ) ;

  double v[18] ;

  // inicializace promenne
  pr.prepare( 21 ) ;

  // inicializace pomocneho nosniku
  TDimBeam *beam;
  beam=alokaceTDB(1) ;

  // inicializace cele konstrukce
  kce=TSKload( "mr.beam/test4.in" ) ;
  dimenzace( kce ) ;
 
  // tisk vzoroveho nosniku dle EC2
  TDBdimprn( kce->pdb );
  TDB_OPprn( kce->pdb );

  // test
  v[0] = 0.2 ;
  v[1] = 0.3 ;
  v[2] = 5. ;
  v[3] = 5. ;
  v[4] = 3. ;
  v[5] = 3. ;
  v[6] = 2. ;
  v[7] = 0. ;
  v[8] = 0. ;
  v[9] = 6. ;
  v[10] = 4. ;
  v[11] = 4. ; 
  v[12] = 4. ;
  v[13] = 4. ;
  v[14] = 2. ;
  v[15] = 0.2 ;
  v[16] = 0.2 ;
  v[17] = 0.125 ;

  printf( "-> Vysledek by mel byt: %f \n", Funkce_rc( v ) ) ;

  printf( "** everything done ** \n" ) ;
  printf( "** \n" ) ;
  return 0 ;
}
