#if !defined ( __MR_BEAM__ )
#define        __MR_BEAM__

#include "../function.h"
#include "variable.h"
#include "rc.h"

class mr_beam : public objective_function
{
    public:
        mr_beam ( void ) ;
       ~mr_beam ( void ) ;
        int new_case ( void ) ;
        int get_dimension ( void ) ;
        int check_domain ( void ) ;
        int make_defined ( double *ox ) ;
        void new_point ( double *ox ) ;
        void get_limits ( int odir , double &omin , double &omax ) ;
        void get_limits ( int odir , double &omin , double &omax , double &oprec ) ;
        void get_value_range ( double &omin , double &omax ) ;
        double value ( double *ox ) ;
    public:
        int do_you_know_yourself ( void ) ;
        int to_be_stopped ( double obsf ) ;
        int how_many_extremes ( void ) ;
        double get_extreme ( int oi , double *ox ) ;
        double get_global_extreme ( double *ox ) ;
    private:
        void round_chrm ( double *Chromo, double *Rounded ) ;
        double *v ;
        TSKce *kce ;
        PopVar pr ;
} ;

#endif

