/*
 * rc_alkts.c		ver. 1.0
 *
 * Soubor pro alokaci promnennych typu
 *
 * M. Leps, 9.11.1998
 *
 */

/*#define PRGDEBUG*/
/* Vyse uvedeni v makefile */

#include "rc.h"

/*
 * V pripade, ze budou fce pracovat jen uvnitr modulu
 * rc_fce.c zmenit GLOBAL na LOCAL a uvest zde prototypy
 */

/* Deklarace LOCAL funkci */
LOCAL void* alokaceTS(long int a,long int sofTS);

/*******************/
/* Definice funkci */
/*******************/

/***********************************************************************************************/
/* Fce pro prideleni pameti */
/* Alokuje a ciselu typu TS velikosti sofTS */

#ifdef BLBOST3
LOCAL void* alokaceTS(long int a,long int sofTS)
{
	void *b;
	b=(void *)calloc (a,sofTS);
	if (b==NULL){
#ifdef DEBUG
		printf ("\n Nelze alokovat pamet.\n");
#endif
		abort ();
	}
	return(b);
}
#endif

/* Alokuje a ciselu typu TSNode */
GLOBAL TSNode* alokaceTSN(long int a)
{
	TSNode *b;
	//b=(TSNode *)(alokaceTS(a,sizeof(TSNode)));
	b=new TSNode[a] ;
	return(b);
}

/* Alokuje a ciselu typu TSElem */
GLOBAL TSElem* alokaceTSE(long int a)
{
	TSElem *b;
	//b=(TSElem *)(alokaceTS(a,sizeof(TSElem)));
	b=new TSElem[a] ;
	return(b);
}

/* Alokuje a ciselu typu TSBeam */
GLOBAL TSBeam* alokaceTSB(long int a)
{
	TSBeam *b;
	//b=(TSBeam *)(alokaceTS(a,sizeof(TSBeam)));
	b=new TSBeam[a] ;
	return(b);
}

/* Alokuje a ciselu typu TDimBeam */
GLOBAL TDimBeam* alokaceTDB(long int a)
{
	TDimBeam *b;
	//b=(TDimBeam *)(alokaceTS(a,sizeof(TDimBeam)));
	b=new TDimBeam[a] ;
	return(b);
}

/* Alokuje a cisel typu TSKce */
GLOBAL TSKce* alokaceTSK(long int a)
{
	TSKce *b;
	//b=(TSKce *)(alokaceTS(a,sizeof(TSKce)));
	b=new TSKce[a] ;
	return(b);
}

/* Alokuje a cisel typu TSSteel */
GLOBAL TSSteel* alokaceTSS(long int a)
{
	TSSteel *b;
	//b=(TSSteel *)(alokaceTS(a,sizeof(TSSteel)));
	b=new TSSteel[a] ;
	return(b);
}

/* Alokuje a cisel typu TSConcr */
GLOBAL TSConcr* alokaceTSC(long int a)
{
	TSConcr *b;
	//b=(TSConcr *)(alokaceTS(a,sizeof(TSConcr)));
	b=new TSConcr[a] ;
	return(b);
}

/* Alokuje a cisel typu TSPop */
GLOBAL TSPop* alokaceTSP(long int a)
{
	TSPop *b;
	//b=(TSPop *)(alokaceTS(a,sizeof(TSPop)));
	b=new TSPop[a] ;
	return(b);
}

/* Alokuje a cisel typu TSVect */
GLOBAL TSVect* alokaceTSV(long int a)
{
	TSVect *b;
	//b=(TSVect *)(alokaceTS(a,sizeof(TSVect)));
	b=new TSVect[a] ;
	return(b);
}

/* Alokuje a cisel typu TSGen */
GLOBAL TSGen* alokaceTSG(long int a,long int prom)
{
  int i;
  TSGen *b;

  //b=(TSGen *)(alokaceTS(a,sizeof(TSGen)));
  b=new TSGen[a] ;
  for(i=0;i<a;i++) {
	 (b+i)->bin=alokaceb(prom);
  }
  return(b);
}

/* Alokuje a cisel typu double */
GLOBAL double* alokacer(long int a)
{
	double *b;
	//b=(double *)(alokaceTS(a,sizeof(double)));
	b=new double[a] ;
	return(b);
}

/* Alokuje a cisel typu bit */
GLOBAL bit* alokaceb(long int a)
{
	bit *b;
	//b=(bit *)(alokaceTS(a,sizeof(bit)));
	b=new bit[a] ;
	return(b);
}

/***********************************************************************************************/
/* Fce pro uvolneni pameti */
/* Uvolni pointer */
GLOBAL void uvolni(void *p)
{
  /*free(p);
   p = NULL;*/
  if( p ) delete [] p ;
}

/* Uvolni TSKce */
GLOBAL void uvolniTSK(TSKce *k)
{
  uvolni((void *) k->r);
  uvolni((void *) k->ps);
  uvolni((void *) k->pc);
  uvolni((void *) k->pn);
  uvolni((void *) k->pe);
  uvolni((void *) k->pb);
  if( k->pdb ) delete [] k->pdb ;
/*  uvolni((void *) k->pdb);*/

  uvolni((void *) k);

  return;
}

/* Uvolni TSPop */
GLOBAL void uvolniTSP(TSPop *p)
{
  int i;

  p->a = NULL;
  uvolni((void *) p->pr);
  for(i=0;i<p->ngen;i++) {
	 uvolniTSG((p->pg)+i);
  }
  uvolni((void *) p->pg);
  uvolni((void *) p);
  return;
}

/* Uvolni TSGen */
GLOBAL void uvolniTSG(TSGen *p)
{
  uvolni((void *) p->bin);
  return;
}
