/*
 * rc_infi.c		ver. 1.0
 *
 * ukladani do souboru
 *
 * M. Leps, 5.12.1998
 *
 */

#include "rc.h"

/*
 * V pripade, ze budou fce pracovat jen uvnitr modulu
 * zmenit GLOBAL na LOCAL a uvest zde prototypy
 */

/* Deklarace LOCAL funkci */
LOCAL void InitWriteVect(TSPop *p);
LOCAL void WriteVect(TSPop *p);

/*******************/
/* Definice funkci */
/*******************/

/***********************************************************************************************/
/* Globalni funkce */
GLOBAL void InitWritePop(TSPop *p,char *jm)
{
  FILE *f;
  if ((f = fopen(jm,"w")) == NULL) {
    printf("Soubor %s se nepodarilo otevrit \n",*jm);
    abort();
  }
  WriteTabPop(p,f);
/*  InitWriteVect(p);*/
  if (fclose(f) == EOF) {
    printf("Soubor %s se nepodarilo uzavrit \n",*jm);
    abort();
  }
  return;
}

GLOBAL void WritePop(TSPop *p,char *jm)
{
  FILE *f;
  if ((f = fopen(jm,"a")) == NULL) {
    printf("Soubor %s se nepodarilo otevrit \n",*jm);
    abort();
  }
  WriteLinePop(p,f,1);
/*  WriteVect(p);*/
  if (fclose(f) == EOF) {
    printf("Soubor %s se nepodarilo uzavrit \n",*jm);
    abort();
  }
  return;
}

GLOBAL void EndWritePop(TDimBeam *b,char *jm)
{
  FILE *f;
  if ((f = fopen(jm,"a")) == NULL) {
    printf("Soubor %s se nepodarilo otevrit \n",*jm);
    abort();
  }
  fprintf(f,"\n");
  WriteVyztuz(b,f);
  WriteCena(b,f);
  if (fclose(f) == EOF) {
    printf("Soubor %s se nepodarilo uzavrit \n",*jm);
    abort();
  }
  return;
}

GLOBAL void WriteLinePop(TSPop *p,FILE *f,int kg)
{
  int i ;
	//int j ;

  for(i=0;i<kg;i++) {
	 fprintf(f,"%6d",p->it);
	 /*    fprintf(f," %4d",p->pg[i].id);
    for(j=0;j<p->npr;j++) {
      fprintf(f,"%4d",p->pg[i].bin[j]); 
    }*/
    fprintf(f," %10.3lf %10.7lf %10.7lf\n",p->pg[i].c,p->pg[i].f,p->pru);
  }
  return;
}

GLOBAL void WriteTabPop(TSPop *p,FILE *f)
{
  //int i;

  fprintf(f,"Vypis nejlepsich genu: \n");
  fprintf(f,"   It  ");
/*  for(i=0;i<p->npr;i++) {
    fprintf(f,"%4ld",i+1);
  }*/
  fprintf(f,"     cena     sila     prumer\n");
  return;
}

GLOBAL void WriteCena(TDimBeam *a,FILE *f)
{
  fprintf(f,"Optimalizacni hodnoty :\n");
  fprintf(f,"Objem betonu :  \t %lf \n",a->tp.vc);
  fprintf(f,"Objem vyztuze : \t %lf \n",a->tp.vs);
  fprintf(f,"Objem trminku : \t %lf \n",a->tp.vsw);
  fprintf(f,"Hmotnost oceli :\t %8.3lf \n",a->tp.ws);
  fprintf(f,"Hmotnost betonu :\t %8.3lf \n\n",a->tp.wc);
  fprintf(f,"Cena betonu :   \t %9.2lf \n",a->tp.cc);
  fprintf(f,"Cena oceli :    \t %9.2lf \n",a->tp.cs);
  fprintf(f,"                \t--------------\n");
  fprintf(f,"Celkem :        \t %9.2lf\n\n",a->tp.c);
  return;
}

GLOBAL void WriteVyztuz(TDimBeam *a,FILE *f)
{
  int i,j;
  TSMdim *m;
  TSWdim *w;

  /* momenty */
  fprintf(f,"Nosnik c.%ld : %4.0lfx%3.0lf \n",a->id,(a->b)*1000,(a->h)*1000);
  fprintf(f,"Id  L       Ms      Mu    Poc/Typ       As    Ro XL EC PR MS MP    x     ksi\n");
  for(i=0;i<3;i++) {
    m = a->m+i;
    fprintf(f,"%2d %2ld H: %7.3lf %7.3lf %2d pr %3.1lf %8.2lf ",\
	    i+1,m->s,m->m[HORNI],m->mu[HORNI],m->as[HORNI].n,(i_pr(a->pr[HORNI]))*1000,(m->as[HORNI].a)*1000000);
    for (j=0;j<6;j++) {
      fprintf(f,"%3d",m->pch[HORNI][j]);
    }
    fprintf(f,"  ");
    for (j=0;j<PROM;j++) {
      fprintf(f," %5.4lf",m->hodn[HORNI][j]);
    }
    fprintf(f,"\n");
    fprintf(f,"      D: %7.3lf %7.3lf %2d pr %3.1lf %8.2lf ",\
	    m->m[DOLNI],m->mu[DOLNI],m->as[DOLNI].n,(i_pr(a->pr[DOLNI]))*1000,(m->as[DOLNI].a)*1000000);
    for (j=0;j<6;j++) {
      fprintf(f,"%3d",m->pch[DOLNI][j]);
    }
    fprintf(f,"  ");
    for (j=0;j<PROM;j++) {
      fprintf(f," %5.4lf",m->hodn[DOLNI][j]);
    }
    fprintf(f,"\n");
  }
  fprintf(f,"\n");

  /* posouvajici sily */
  fprintf(f,"Id  L    Qs      Qrd  Strih/Typ   a' Check\n");
  for(i=0;i<3;i++) {
    w = a->w+i;
    fprintf(f,"%2d %2ld %7.3lf %7.3lf %2d pr%2.0lf    %3.0lf   %1d",\
	    i+1,w->s,w->q,w->qu,w->pw,w_pr(a->prw)*1000,(w->sw)*1000,w->pch[0]);
    fprintf(f,"\n");
  }
  fprintf(f,"\n");
  return;
}

/***********************************************************************************************/
/* Globalni funkce */
LOCAL void InitWriteVect(TSPop *p)
{
  int i;
  FILE *f;
  char jm[50];
  strcpy(jm,ADROUT);
  strcat(jm,FVYST);
  strcat(jm,FEND);
  if ((f = fopen(jm,"w")) == NULL) {
    printf("Soubor fcetab.otf se nepodarilo otevrit \n");
    abort();
  }
  fprintf(f,"Sily pr. :\n");
  fprintf(f,"  It");
  for(i=0;i<p->npr;i++) {
    if((p->pr+i)->opt == 1)
      fprintf(f,"  %2ld  ",i+1);
  }
  fprintf(f,"\n");
  if (fclose(f) == EOF) {
    printf("Soubor fce.tab se nepodarilo uzavrit \n");
    abort();
  }
  return;
}

LOCAL void WriteVect(TSPop *p)
{
  int i;
  FILE *f;
  char jm[50];
  strcpy(jm,ADROUT);
  strcat(jm,FVYST);
  strcat(jm,FEND);
  if ((f = fopen(jm,"a")) == NULL) {
    printf("Soubor fcetab.otf se nepodarilo otevrit \n");
    abort();
  }
  fprintf(f,"%4ld",p->it);
  for(i=0;i<p->npr;i++) {
    if((p->pr+i)->opt == 1)
      fprintf(f," %4.3lf",(p->pr+i)->f);
  }
  fprintf(f,"\n");
  if (fclose(f) == EOF) {
    printf("Soubor fcetab.otf se nepodarilo uzavrit \n");
    abort();
  }
  return;
}

