/*
 * rc_jm.c		ver. 1.0
 *
 * pridelovani jmen souboru
 *
 * M. Leps, 7.12.1998
 *
 */

#include "rc.h"

/* Deklarace LOCAL funkci */
LOCAL void HelpRun(void);
LOCAL void Implicit(TProstr *p);
LOCAL void Updatejm(char *jm,int co);

/*******************/
/* Definice funkci */
/*******************/

/***********************************************************************************************/
/* Globalni funkce */
GLOBAL void LoadProstr(int argc, char *argv[ ],TProstr *p)
{
  char s;
  char *rest ;
  int i;
  if(argc == 1) {
    HelpRun();
    exit(0);
  }
  Implicit(p);

  for(i=1;i<argc;i++) {
    s=argv[i][0];
	rest=argv[i]+1 ;
    if(s=='i') {
      return;}
    if(s=='n') {
      sscanf(  rest, "%d", p->iter ) ;
	  /*p->iter = atoi(argv[i]+1);*/
      continue;}
    if(s=='g') {
      sscanf(  rest, "%d", p->pocg);
      continue;}
    if(s=='k') {
      sscanf(  rest, "%d", p->krok);
      continue;}
    if(s=='p') {
      sscanf(  rest, "%d", p->pocop);
      continue;}
    if(s=='s') {
      sscanf(  rest, "%d", p->vyber);
      continue;}
    if(s=='r') {
      sscanf(  rest, "%d", p->reseni);
      continue;}
    if(s=='f'){
      strcpy(p->fin,ADRIN);
      strcpy(p->fin,argv[i]+1);
      continue;}
    if(s=='o'){
      strcpy(p->fopt,ADRIN);
      strcat(p->fopt,OPTPRM);
      strcat(p->fopt,argv[i]+1);
      continue;}
    else {
      HelpRun();
      exit(0);
    }      
  }
  return;
}

GLOBAL void Updatevy(TProstr *p,int cislo)
{
#ifndef DEBUG
  strcpy(p->out,ADROUT);
  strcat(p->out,VVYST);
  Updatejm(p->out, p->reseni);
  Updatejm(p->out, p->vyber);
  strcat(p->out,"_");
  Updatejm(p->out,cislo);
  strcat(p->out,VEND);
#endif
  return;
}

/***********************************************************************************************/
/* Lokalni fce */
LOCAL void Updatejm(char *jm,int co)
{
  char st[8];
  sprintf(st,"%d",co);
  strcat(jm,st);
  return;
}

LOCAL void Implicit(TProstr *p)
{
  p->pocop = OPAK;
  p->iter = IT;
  p->krok = KROK;
  p->pocg = NGEN;
  p->vyber = RAND;
  p->reseni = ING;
  strcpy(p->fin,ADRIN);
  strcat(p->fin,TEST);
  strcpy(p->fopt,ADRIN);
  strcat(p->fopt,OPTPRM);
  strcat(p->fopt,NOPT);
  return;
}

LOCAL void HelpRun(void)
{
  printf("Run test.exe with : \n\n"); 
  printf("i                 for implicit run   [IMPL.](POSS):\n");
  printf("[ffilename]       input file         [test4.in]\n"); 
  printf("[n#]              # of iterations    [100]\n"); 
  printf("[o#]              # of optprm file   [11](12,13,21,22,23)\n"); 
  printf("[g#]              # of gens          [200]\n"); 
  printf("[k#]              # of steps         [100]\n"); 
  printf("[p#]              # of repeats       [1]\n"); 
  printf("[s#]              start population   [Rand=0](Init=1)\n");
  printf("[r#]              typ reseni         [Ing=0](Mat=1)\n");
  printf("\n");
  return;
}
