/*
 * rc_load.c		ver. 1.0
 *
 * Soubor k nacitani prommenych
 *
 * M. Leps, 5.12.1998
 *
 */

#include "rc.h"

/*
 * V pripade, ze budou fce pracovat jen uvnitr modulu
 * zmenit GLOBAL na LOCAL a uvest zde prototypy
 */

/* Deklarace LOCAL funkci */
LOCAL void nullTSM(TSMdim *m);
LOCAL void nullTSW(TSWdim *w);

/*******************/
/* Definice funkci */
/*******************/

/***********************************************************************************************/
/* Fce pro nacteni materialu */
/* Nacteni oceli, vraci pocet typu */
GLOBAL TSSteel* TSSload(int *ns)
{
  TSSteel *a,*ps;
  FILE *fs;
  int i;
  char jm[50];
  strcpy(jm,ADRIN);
  strcat(jm,STEEL);

  if ((fs = fopen(jm, "r")) == NULL) {
	 printf("Soubor steel se nepodarilo otevrit \n");
	 abort();
  }

  fscanf(fs,"%ld",ns);
  a = alokaceTSS(*ns);

  for(i=0;i<(*ns);i++) {
	 ps = a+i;
	 fscanf(fs,"%ld %lf %lf %lf",&(ps->id),\
			  &(ps->fyk),&(ps->ga),&(ps->es));
	 ps->fyd = ps->fyk/ps->ga;
	 /* cena */
	 ps->c1 = 50.0;
  }

  if (fclose(fs) == EOF) {
	 printf("Soubor steel se nepodarilo uzavrit \n");
	 uvolni((void *) a);
	 abort();
  }
  ps = NULL;
  return(a);
}

/* Nacteni betonu, vraci pocet typu */
GLOBAL TSConcr* TSCload(int *nc)
{
  TSConcr *a,*pc;
  FILE *fc;
  int i;
  char jm[50];
  strcpy(jm,ADRIN);
  strcat(jm,CONCR);

  if ((fc = fopen(jm, "r")) == NULL) {
	 printf("Soubor concr se nepodarilo otevrit \n");
	 abort();
  }

  fscanf(fc,"%ld",nc);
  a = alokaceTSC(*nc);

  for(i=0;i<(*nc);i++) {
	 pc = a+i;
	 fscanf(fc,"%ld %lf %lf %lf %lf %lf %lf",&(pc->id),\
			  &(pc->fck),&(pc->fctm),&(pc->fctk05),&(pc->ecm),&(pc->gc),&(pc->gcw));
	 pc->fcd = pc->fck/pc->gc;
	 /* cena */
	 pc->c1 = 1350.0;
  }

  if (fclose(fc) == EOF) {
	 printf("Soubor concr se nepodarilo uzavrit \n");
	 uvolni((void *) a);
	 abort();
  }
  pc = NULL;
  return(a);
}

/* Nacteni kce ze souboru "jmeno" */
GLOBAL TSKce* TSKload(char *jmeno)
{
  int pr;
  int prw;
  int i,j,itmpa,itmpb,itmpc;
  TSKce *kce;
  TSNode *pn;
  TSElem *pe;
  TSBeam *pb;
  TDimBeam *pdb;
  FILE *fin;

  /* inicializace hodnot */
  pr = 5;
  prw = 1;

  /* nacteni testovacich hodnot */
  if ((fin = fopen(jmeno, "r")) == NULL) {
	 printf("Soubor %s se nepodarilo otevrit \n",jmeno);
	 abort();
  }

  kce = alokaceTSK(1);

  /*  cteni zakladnich dat  */
  fscanf (fin,"%ld %ld %ld %ld %ld",\
			 &(kce->id),&(kce->nn),&(kce->ne),&(kce->nb),&(kce->nc));

  kce->ps = TSSload(&(kce->nsteel));
  kce->pc = TSCload(&(kce->nconcr));

/*TSKprn(kce);*/

  kce->pn = alokaceTSN(kce->nn);
  kce->pe = alokaceTSE(kce->ne);
  kce->pb = alokaceTSB(kce->nb);
  kce->pdb = alokaceTDB(kce->nb);

  kce->r =  alokacer(kce->nc);

  /* nacteni uzlu */
  for(i=0;i<kce->nn;i++) {
	 pn = (kce->pn)+i;
	 fscanf(fin,"%ld", &(pn->id));
	 fscanf (fin,"%lf %lf %lf %lf %lf",&(pn->x),&(pn->y),\
				&(pn->f[0]),&(pn->f[1]),&(pn->f[2]));
	 fscanf (fin,"%ld %ld %ld %ld %ld %ld",&(pn->p[0]),&(pn->p[1]),&(pn->p[2]),\
				&(pn->kc[0]),&(pn->kc[1]),&(pn->kc[2]));
  }

  /* nacteni elemntu */
  for(i=0;i<kce->ne;i++) {
	 pe = (kce->pe)+i;
	 fscanf (fin,"%ld %ld %ld %ld %lf %lf %lf",&(pe->id),\
				&itmpc,&itmpa,&itmpb,&(pe->ei),&(pe->ea),&(pe->l));
	 pe->na = (kce->pn)+itmpa-1;
	 pe->nb = (kce->pn)+itmpb-1;
	 for(j=0;j<6;j++) {
		fscanf (fin,"%ld",&(pe->kc[j]));
	 }
	 for(j=0;j<6;j++) {
		fscanf (fin,"%lf",&(pe->f[j]));
	 }

	 /* pointer na nadrazeny nosnik */
	 pb = (kce->pb)+itmpc-1;
	 pe->pb = pb;                   /* ! (void *) */
  }

  /* nacteni nosniku */
  pe = (kce->pe);
  for(i=0;i<kce->nb;i++) {
	 pb = (kce->pb)+i;
	 pdb  = (kce->pdb)+i;
	 nullTDB(pdb);
	 pdb->pb = pb;
	 fscanf (fin,"%ld %ld %ld %ld %lf %lf %lf",\
				&(pb->id),&(pb->ne),&itmpa,&itmpb,&(pb->b),&(pb->h),&(pb->l));
	 pdb->id = pb->id;
	 pdb->ne = pb->ne;
	 pdb->h = pb->h;
	 pdb->b = pb->b;
	 pdb->l = pb->l;

	 /* uzly */
	 pb->na = (kce->pn)+itmpa-1;
	 pb->nb = (kce->pn)+itmpb-1;
	 /* elementy */
	 pb->pe = pe;
	 pe += pb->ne;
	  
	 /* materialove charakteristiky */
	 fscanf (fin,"%ld %ld %ld",\
				&itmpa,&itmpb,&itmpc);
	 pdb->pc = (kce->pc)+itmpa-1;
	 pdb->ps = (kce->ps)+itmpb-1;
	 pdb->psw = (kce->ps)+itmpc-1;
	 pdb->alfa = pdb->ps->es/pdb->pc->ecm;

	 pdb->prw = prw;
	 pdb->pr[0] = pr;
	 pdb->pr[1] = 5;
	 pdb->c[0] = vypocc(SMRAZEM,pdb->pr[0],prw);
	 pdb->c[1] = vypocc(SMRAZEM,pdb->pr[1],prw);
	 pdb->m[0].s = pdb->ne/3;
	 pdb->m[1].s = (pdb->ne - pdb->m[0].s)/2;
	 pdb->m[2].s = pdb->ne - (pdb->m[0].s + pdb->m[1].s);
	 pdb->w[0].s = pdb->m[0].s;
	 pdb->w[1].s = pdb->m[1].s;
	 pdb->w[2].s = pdb->m[2].s;
  }

  if (fclose(fin) == EOF) {
	 printf("Soubor %s se nepodarilo uzavrit \n",jmeno);
	 uvolniTSK(kce);
	 abort();
  }

  return(kce);
}

/***********************************************************************************************/
/* Nulovaci fce */
GLOBAL void nullTDB(TDimBeam *b)
{
  int i;

  b->id = 0;
  b->ne = 0;
  b->l = 0.0;
  b->b = 0.0;
  b->h = 0.0;
  b->alfa = 0.0;
  b->pr[0] = 0;
  b->pr[1] = 0;
  b->c[0] = 0.0;
  b->c[1] = 0.0;
  b->ch[0] = 0;
  b->ch[1] = 0;
  b->prw = 0;

  for(i=0;i<3;i++) {
	 nullTSM(b->m+i);
	 nullTSW(b->w+i);
  }
  return;
}

LOCAL void nullTSM(TSMdim *m)
{
  int i;
  m->m[0] = 0.0;
  m->m[1] = 0.0;
  m->mu[0] = 0.0;
  m->mu[1] = 0.0;
  m->as[0].a = 0.0;
  m->as[1].a = 0.0;
  m->as[0].n = 0;
  m->as[1].n = 0;
  m->d[0] = 0.0;
  m->d[1] = 0.0;
  m->r[0] = 0;
  m->r[1] = 0;
  m->s = 0;
  nulmat(i,PROM,m->hodn[0]);
  nulmat(i,PROM,m->hodn[1]);
  nulmat(i,6,m->pch[0]);
  nulmat(i,6,m->pch[1]);
}

LOCAL void nullTSW(TSWdim *w)
{
  w->q = 0.0;
  w->qu = 0.0;
  w->sw = 0.0;
  w->s = 0;
  w->pw = 0;
  w->pch[0] = BAD;
}
