/*
 * rc_prog.c		ver. 1.01
 *
 * Soubor vyuzivajici fce z rc_fce.c pro optimalizaci
 *
 * M. Leps, 15.11.1998
 *
 */

#include "rc.h"

/*
 * V pripade, ze budou fce pracovat jen uvnitr modulu
 * rc_fce.c zmenit GLOBAL na LOCAL a uvest zde prototypy
 */

/* Deklarace LOCAL funkci */

/*******************/
/* Definice funkci */
/*******************/

/***********************************************************************************************/
/* Fce zkontroluje na kci MS pretvoreni */
GLOBAL void checkmsp(TSKce *pk)
{
  int poc[3];
  int i,j,k,n;
  TSElem *pe;
  TSBeam *pb;
  TDimBeam *pdb;
  double m[2],mr;
  double b1,b2;
  double wlim;      /* limitni pruhyb */
  double rl[4];     /* pole posunu na elementu */

  /* predpoklady : jiz byly spocteny vnitrni sily */
  /*               posuzuji se posuny, tj. prvni a druhe nezname v uzlech */

  b1 = 1.0;       /* vyztuz s velkou soudrznosti */
  b2 = 0.5;       /* dlouhodobe zatizeni */

  for(k=0;k<pk->nb;k++) {
	 pdb = pk->pdb+k;
	 pb = pk->pb+k;
	 poc[0] = 0;
	 poc[1] = pdb->m[0].s;
	 poc[2] = pdb->m[0].s + pdb->m[1].s;
	 for(j=0;j<3;j++) {
		for(i=poc[j];i<(poc[j]+pdb->m[j].s);i++) {
		  pe = pb->pe+i;
		  m[0] = -(pe->s[2]);
		  m[1] = pe->s[5];
		  n = (fabs(m[0]) < fabs(m[1])) ? 1 : 0;
		  mr = fabs(m[n]);
		  n = (m[n] < 0) ? HORNI : DOLNI;
		  vypocei(&(pe->ei),(mr/1.2),pdb->m[j].as[n].a,pdb->b,pdb->h,pdb->m[j].d[n],\
					 pdb->pc->fctm,b1,b2,pdb->ps->es,pdb->pc->ecm,pdb->alfa);
		}
	 }
  }

  defmetod(pk);

	double wmax=0. ;
	int ikc ;

  for(i=0;i<pk->nb;i++) {
		pdb = pk->pdb+i;
		pb = (pk->pb)+i;
		wlim = pb->l/250;
		for(j=0;j<pb->ne;j++) {
			pe = (pb->pe)+j;
			pe->ch = GOOD;
			// 1. posun
			ikc=(pe->na->kc[0])-1 ;
			if( ikc<0 )
				rl[0]=0. ;
			else
				rl[0] = fabs(pk->r[ikc]);
			// 2. posun
			ikc=(pe->na->kc[1])-1 ;
			if( ikc<0 )
				rl[1]=0. ;
			else
				rl[1] = fabs(pk->r[ikc]);
			// 3. posun
			ikc=(pe->nb->kc[0])-1 ;
			if( ikc<0 )
				rl[2]=0. ;
			else
				rl[2] = fabs(pk->r[ikc]);
			// 4. posun
			ikc=(pe->nb->kc[1])-1 ;
			if( ikc<0 )
				rl[3]=0. ;
			else
				rl[3] = fabs(pk->r[ikc]);
			for(k=0;k<4;k++) {
				if(rl[k] > wmax) {
					wmax=rl[k] ;
				}
			}
		}
		if( wmax>wlim ) {
			printf( "-- w=%9lf <= wlim=%9lf -- \n ", wmax, wlim ) ;
			printf( "-- Nevyhovel na msp ! -- \n " ) ;
			pe->ch = BAD;
		}
		else {
			printf("** OK msp ** \n");
		}
  }
  return;
}

/***********************************************************************************************/
/* Fce navrhne vyztuz v cele kci */
GLOBAL void kceDim(TSKce *pk)
{
  int i;
  TSBeam *pb;
  TDimBeam *pdb;

  /* Vypocet deformacni metodou */
  defmetod(pk);

  /* Predani prubehu vnitrnich sil dimenzaci */
  for(i=0;i<pk->nb;i++) {
	 pb = pk->pb+i;
	 pdb = pk->pdb+i;
	 FEtoDim(pdb,pb);
  }

  /* Navrh vyztuze */
  for(i=0;i<pk->nb;i++) {
	 pdb = pk->pdb+i;
	 initnav(pdb);
	 DimCheck(pdb);
  }

  /* kontrola MSP */
/*  checkmsp(pk);*/

#ifdef DEBUG
	 TSKallprn(pk);
#endif

  return;
}

/***********************************************************************************************/
/* Fce navrhne vyztuz v cele kci */
GLOBAL void DimCheck(TDimBeam *pdb)
{
  int i,j;
  double *as;
	double all_as ;
  TSMdim *pe;
  TSWdim *pw;
  double romin;
  double smin[4] = { 0.15, 0.10, 0.075, 0.050};       /* zv. dov. minimalni vzdalenosti tr. */
  int concrid [9] = { 0, 0, 0, 1, 1, 1, 2, 2, 2};     /* prevod typu betonu na trojici */
  double ro[3][3] = { { 0.0009, 0.0005, 0.0004} ,     /* ro minimalni dle NAD */
							 { 0.0013, 0.0007, 0.0006} ,     /* [beton] [ocel] */
							 { 0.0017, 0.0009, 0.0007} };

  romin = ro[concrid[(pdb->pc->id)-1]][(pdb->ps->id)-1];

  pdb->c[0] = vypocc(SMRAZEM,pdb->pr[0],pdb->prw);
  pdb->c[1] = vypocc(SMRAZEM,pdb->pr[1],pdb->prw);
  for(i=0;i<3;i++) {
		pe = &(pdb->m[i]);
		for(j=0;j<2;j++){
			if(pe->m[j] == 0.0)
				continue;
			as = &(pe->as[j].a);
			/* kontrola MSU */
			checknav(pe->hodn[j],pe->pch[j],&(pe->d[j]),pe->m[j],&(pe->mu[j]),*as,pdb->b,pdb->h,pdb->c[j],pe->as[j].n,i_pr(pdb->pr[j]),\
					pdb->ps->fyk,pdb->ps->fyd,pdb->pc->fck,pdb->pc->fcd);
		}
		/* kontrola stupne vyztuzeni */
		all_as=pe->as[0].a+pe->as[1].a ;
		pe->pch[0][0]=pe->pch[1][0]=checkv(all_as,pdb->b,pdb->h,(pe->d[0]-pdb->c[1]), pdb->ps->fyk); // nepresne

		/* kontrola smyku */
		pw = &(pdb->w[i]);
		if(pw->q == 0)
			continue;
		pw->pch[0] = checkAsw(&(pw->qu),pw->pw,pw->sw,w_pr(pdb->prw),pdb->m[i].as[DOLNI].a,pw->q,pdb->b,pdb->m[i].d[DOLNI],\
								  pdb->pc->fck,pdb->pc->fcd,pdb->pc->fctk05,pdb->pc->gc,pdb->psw->fyd,romin,smin[pdb->prw]);
  }
  return;
}

/***********************************************************************************************/
/* Fce vytvori z vnitrnich sil dimenzacni veliciny */
GLOBAL void FEtoDim(TDimBeam *pdb,TSBeam *pb)
{
/* add new 070999 by Matej */
#define zkr(a) ((floor((a)*1000.0))/1000.0)

  int i,j;
  TSElem *pe;
  double extr[2];
  int poc[3];

  for(j=0;j<3;j++){
	 poc[0] = 0;
	 poc[1] = pdb->m[0].s;
	 poc[2] = pdb->m[0].s + pdb->m[1].s;
	 extr[0] = 0.0;
	 extr[1] = 0.0;
	 /* moment */
	 for(i=poc[j];i<(poc[j]+pdb->m[j].s);i++) {
		pe = pb->pe+i;
		pdb->m[j].m[0] = -(pe->s[2]); /* kladne momenty tahnou spodni vlakna */
		pdb->m[j].m[1] =  (pe->s[5]);
		if(pdb->m[j].m[0] > extr[DOLNI])
		  extr[DOLNI] = pdb->m[j].m[0];
		else if(pdb->m[j].m[0] < extr[HORNI])
		  extr[HORNI] = pdb->m[j].m[0];
		if(pdb->m[j].m[1] > extr[DOLNI])
		  extr[DOLNI] = pdb->m[j].m[1];
		else if(pdb->m[j].m[1] < extr[HORNI])
		  extr[HORNI] = pdb->m[j].m[1];
	 }
	 pdb->m[j].m[DOLNI] = zkr( fabs(extr[DOLNI])) ;
	 pdb->m[j].m[HORNI] = zkr( fabs(extr[HORNI])) ;

	 poc[0] = 0;
	 poc[1] = pdb->w[0].s;
	 poc[2] = pdb->w[0].s + pdb->w[1].s;
	 pdb->w[j].q = 0.0;
	 /* posouvajici sila */
	 for(i=poc[j];i<(poc[j]+pdb->w[j].s);i++) {
		pe = pb->pe+i;
		extr[0] = fabs(pe->s[1]);
		extr[1] = fabs(pe->s[4]);
		if(extr[0] > pdb->w[j].q)
		  pdb->w[j].q = extr[0];
		if(extr[1] > pdb->w[j].q)
		  pdb->w[j].q = extr[1];
	 }
  }
  return;
}

/***********************************************************************************************/
/* Fce na kontrolu a upravu inicializace */
GLOBAL void initnav(TDimBeam *pdb)
{
   /* Pozor ! upravuje prurez nosniku */
  int i;

  pdb->ch[0] = ZMENA;
  for (i = 0;((pdb->ch[0] == ZMENA) && (i < 8));i++) {
	 initas(pdb);
	 if (pdb->ch[0] == ZMENA) {
		pdb->h += 0.05;             /* zvetseni prurezu */
#ifdef DEBUG
		printf("Zmena prurezu !");
#endif
		continue;
	 }
	 pdb->ch[0] = initasw(pdb);
	 if (pdb->ch[0] == ZMENA) {
		pdb->h += 0.05;             /* zvetseni prurezu */
#ifdef DEBUG
		printf("Zmena prurezu !");
#endif
		continue;
	 }
  }
  return;
}

/***********************************************************************************************/
/* Fce na inicializaci navrhu vyztuze */
GLOBAL void initas(TDimBeam *pdb)
{
  int i,j,k,*p_b;
  double *as;
  TSMdim *pe;

  /* pro vsechny elemnty daneho nosniku */
  pdb->ch[0] = GOOD;
  for(i=0;i<3;i++) {
	 pe = &(pdb->m[i]);
	 for(j=0;j<2;j++){
		if(pe->m[j] == 0)
		  continue;
		as = &(pe->as[j].a);
		p_b = pe->pch[j];
		p_b[3] = BAD;
		/* vypocet d */
		pe->d[j] = vypocd(&(pe->r[j]),pdb->b,pdb->h,1,i_pr(pdb->pr[j]),(npr_as(1,i_pr(pdb->pr[j]))),pdb->c[j]);
		/* vypocet vyztuze */
		while (p_b[3] == BAD) {
		  p_b[0] = navrhv(as,pe->m[j],pdb->b,pe->d[j],pdb->ps->fyk,pdb->ps->fyd,pdb->pc->fcd);
		  if (p_b[0] != GOOD) {
			 for (k=0;k<5;k++) {
				p_b[k] = ERRLOWC;
				pdb->ch[0] = ZMENA;
			 }
			 return; /* neuspesny navrh, nutno zvetsit prurez */
		  }
		  /* vypocet poctu prutu */
		  pe->as[j].n = pocetv(as,i_pr(pdb->pr[j]));
		  /* kontrola poctu prutu v rade */
		  p_b[3] = checkpr(pdb->b,pe->as[j].n,i_pr(pdb->pr[j]),pdb->c[j],pe->r[j]);
		  /* vypocet d */
		  pe->d[j] = vypocd(&(pe->r[j]),pdb->b,pdb->h,pe->as[j].n,i_pr(pdb->pr[j]),*as,pdb->c[j]);
		}
		/* kontrola MSU */
		checknav(pe->hodn[j],p_b,&(pe->d[j]),pe->m[j],&(pe->mu[j]),*as,pdb->b,pdb->h,pdb->c[j],pe->as[j].n,i_pr(pdb->pr[j]),\
					pdb->ps->fyk,pdb->ps->fyd,pdb->pc->fck,pdb->pc->fcd);
		for (k = 0;k < 3;k++) {
		  if (p_b[k] == ERRLOWC) {
			 pdb->ch[0] = ZMENA;
		  }
		}
	 }
  }
  return;
}

/***********************************************************************************************/
/* Fce na kontrolu navrhu vyztuze a unosnosti */
GLOBAL void checknav(double *hodn,int *p_b,double *d,double m,double *mu,double as,double b,double h,double c,\
					  int n,double pr,double fyk,double fyd,double fck,double fcd)
{
  int r;

  /* vypocet d */
	*d = vypocd(&r,b,h,n,pr,as,c);
	if(*d == 0)
	  return;

	/* kontrola xlim */
	p_b[1] = checkxlim(hodn+PR_X,as,b,*d,fyd,fck,fcd);
	p_b[2] = p_b[1];

	if (p_b[1] == ERRLOWCEC) {
		p_b[1] = GOOD;
		p_b[2] = ERRLOWC;
	}

	/* kontrola momentu dle MSU */
	p_b[4] = checkmsu(m,mu,as,b,*d,fyd,fcd);

	/* pocet rad vyztuze */
	p_b[3] = r;

	/* KSI */
	hodn[PR_KSI] = hodn[PR_X]/(*d);
	return;
}

/***********************************************************************************************/
/* Fce na inicializaci navrhu vyztuze */
GLOBAL int initasw(TDimBeam *pdb)
{
  int i,j;
  int yn_1;
  double romin;
  TSWdim *pe;
  double smin[4] = { 0.15, 0.10, 0.075, 0.050};       /* zv. dov. minimalni vzdalenosti tr. */
  int concrid [9] = { 0, 0, 0, 1, 1, 1, 2, 2, 2};     /* prevod typu betonu na trojici */
  double ro[3][3] = { { 0.0009, 0.0005, 0.0004} ,     /* ro minimalni dle NAD */
							 { 0.0013, 0.0007, 0.0006} ,     /* [beton] [ocel] */
							 { 0.0017, 0.0009, 0.0007} };

  romin = ro[concrid[(pdb->pc->id)-1]][(pdb->ps->id)-1];

#ifdef RCDEBUG
  printf("Ro min : %lf\n",romin);
#endif

  yn_1 = ZMENA;
  /* v celem nosniku stejne profily */
  for(j=0;(yn_1 == ZMENA) && (j<4);j++) {
	 pdb->prw = j;
	 /* pro vsechny elemnty daneho nosniku */
	 for(i=0;i<3;i++) {
		pe = &(pdb->w[i]);
		yn_1 = vypocasw(&(pe->qu),&(pe->pw),&(pe->sw),w_pr(pdb->prw),pdb->m[i].as[DOLNI].a,pe->q,pdb->b,pdb->m[i].d[DOLNI],\
					pdb->pc->fck,pdb->pc->fcd,pdb->pc->fctk05,pdb->pc->gc,pdb->psw->fyd,romin,smin[j]);
		if(yn_1 == ZMENA) 
		  break;
		else if(yn_1 == BAD)
		  return(BAD);
	 }
  }

  return(yn_1);
}
