/*
 * rc_run.c		ver. 1.0
 *
 * sposti hlavni procedury
 *
 * M. Leps, 8.12.1998
 *
 */

#include "rc.h"

/* Deklarace LOCAL funkci */

/*******************/
/* Definice funkci */
/*******************/

/***********************************************************************************************/
/* Globalni funkce */
/* dimenzace kce */
GLOBAL void dimenzace(TSKce *kce)
{
  int i;
  /* vypocet vyztuze */
  kceDim(kce);
  /* urceni ceny navrhu */
  for(i=0;i<kce->nb;i++) {
    OP_DBcena(kce->pdb+i);
#ifdef DEBUG
    TDB_OPprn(kce->pdb+i);
#endif
  }
  return;
}

#ifdef ALGORITMUS


/* pocatek optimalizace */
GLOBAL void InitOpt(TSPop *pop,TSKce *kce,TSPop *gb,TProstr *o)
{
  seta(pop,0);
  /*OP_D_to_bin(kce->pdb,gb);*/ /* prevod kce na gen */
  kce->pdb->gen = gb->pg;             /* a jeho prirazeni kci */
  G_copy(pop->pg,gb->pg,gb->npr);     /* jeho kopie do populace */
  InitPop(pop,o->vyber);              /* inicializace populace */
  OP_silaPop(pop,kce->pdb,NEWPOP);    /* vypocet sil pop */
  SortPopNew(pop);                      /* utrideni pro tisk */
#ifdef DEBUG
  TSPallprn(pop);
#endif
}

/* prubeh jednoho cyklu optimalizace */
GLOBAL void optimalizace(TSPop *pop,TSKce *kce,TSPop *gb,TProstr *o)
{
  int i;
 
  /*  if(o->akce == KAREL2) {
     for(i=0;i<o->pociter;i++) {
       seta(pop,1);
       RndGen(pop);
      O P_silaPop(pop,kce->pdb,NEWPOP);
      SG AInNew2(pop);
      OP_ silaPop(pop,kce->pdb,NEWGEN);
      SGAO ut3(pop);
    } 
  } 
  else { */

  for(i=0;i<o->krok;i++) {
    SGAInNew(pop);
    OP_silaPop(pop,kce->pdb,NEWGEN);
    SGAOut2(pop);
  }
  SortPopNew(pop);
  pop->it += o->krok;
#ifdef DEBUG
  TSGprn(pop);
#endif
  return;
}

#endif

/* vypis optimalizace */
GLOBAL void Optimprn(TDimBeam *beam, PopVar &p, TSKce *kce )
{
  nullTDB(beam);
  /*seta(pop,0);*/
  OP_oldtonew(beam,kce->pdb,p );
/*#ifdef DEBUG*/
/*  TDBprn(beam);*/
  TDBdimprn(beam);
  TDB_OPprn(beam);
/*#endif*/
}
