/*
 * test.c		ver. 1.09
 *
 * Soubor na testovani fci v RC
 *
 * M. Leps, 5.12.1998
 *
 */

#include "rc.h"

static TSKce  *kce ;

void pokus ( PopVar &p )
{
  OP_silaGen(  p, kce->pdb ) ;
}

/* Hlavni program */
int pokus_main(int argc, char *argv[ ])
{
#ifdef DEBUG
  /* GA */
  tpop p ;


  TProstr pr;
  int i,k;
  TDimBeam *beam;
  TSPop *pop,*gb;

  printf("Zacatek programu. \n");

  p.igl=GlobalMin ; /* co hledam */
  p.its=GoldF ;    /* jaka sila */
  p.imt=Gold ;      /* typ metody */

  LoadProstr(argc,argv,&pr);

  beam = alokaceTDB(1);
  kce = TSKload(pr.fin);
  gb = OP_initVect(1,pr.fopt,pr.reseni);               /* uchova gen dimenzacni kce */
  dimenzace(kce);


  /*optimalizace new */
  p.load_pr ( "optprm.in" ) ;
  p.init_mem ( 200 ) ;
  p.set_F ( pokus ) ;

#define BLBOST2
#ifdef BLBOST2

  p.print_fce() ;

#else

  p.random_gen () ;
  /*p.print_all () ;*/
  p.print_stat() ;
  p.print_best() ;

  /*  printf( "\n") ;*/

  p.run3( 500, 50 ) ;

  p.get_F( p.ngall ) ;

  Optimprn(beam,p.pg[p.ngall].pt,kce);
  p.print_best_1() ;

  TDimBeam bnew, *oldb;
  nullTDB(&bnew);
  OP_oldtonew(&bnew,kce->pdb,p.pg[p.ngall].pt);
  oldb=kce->pdb ;
  delete [] oldb ;
  kce->pdb=&bnew ;
  checkmsp(kce) ;

#endif

#ifdef BLBOST

  /* opakovani optimalizace */
  for(i=0;i<pr.pocop;i++){

#ifndef DEBUG
    Updatevy(&pr,i);
#endif

    /*pop = OP_initVect(pr.pocg,pr.fopt,pr.reseni);*/      /* vytvoreni populace genu */
    /*InitOpt(pop,kce,gb,&pr);*/

#ifndef DEBUG
    InitWritePop(pop,pr.out);
    WritePop(pop,pr.out);
#endif

    /* pres pocet iteraci */
    for(k=0;k<pr.iter;k++) {
      optimalizace(pop,kce,gb,&pr);

#ifndef DEBUG
      WritePop(pop,pr.out);
#endif
    }

    Optimprn(beam,p.pg[p.find_best( GlobalMin )].pt,kce);

#ifndef DEBUG
    EndWritePop(beam,pr.out);
#endif

    uvolniTSP(pop);
  }
#endif /*BLBOST*/


  /* uvolnovani pameti a zavirani souboru */
  uvolni((void *) beam);
  uvolniTSK(kce);
  uvolniTSP(gb);
#ifdef DEBUG
  printf("Regulerni konec programu. \n");
#endif

#endif
  return(0);
}
