#if !defined ( __OBJECTIVE_FUNCTION__ )
#include "function.h"
#endif

class neuronka : public objective_function
{
    public:
        neuronka ( void );
        ~neuronka ( void );
        double value ( double *oCH );

        void initialize ( double oalpha ) ;
        void finalize ( void ) ;

        void layers_prepare ( int on ) ;
        void layers_add ( int on ) ;

        void evaluate ( double *oCH ) ;
        void test ( p_double oI , p_double otarget ) ;
    private:
        void alloc ( void ) ;
        int getindex ( int &olayer , int &oprev , int &othis ) ; // inline
        double activate ( double &osum ) ;
        void propagate ( void ) ;
        void output_error ( p_double otarget ) ;

        double alpha ;     // gain of an activation function

        int layers ;      // # of layers
        p_int lunits ;    // # of neurons in each layer

        int nunits ;   // total # of neurons in net inc. biases
        int last ;     // last layer
        p_double weight, dweight, weightsave ;
        p_int index ; // starting index of each layer in weight[], dweight[] & weightsave[]
        p_double* output ;
        double nerror ;


};
